﻿using Connected.Data.DataProtection;
using Connected.Data.EntityProtection;
using Connected.Middleware;
using Connected.ServiceModel;
using Logistics.Documents.Receive;

namespace Logistics.Documents.Protection;
internal sealed class ReceiveProtector : MiddlewareComponent, IEntityProtector<IReceiveDocument>
{
	public ReceiveProtector(IReceiveDocumentService documents)
	{
		Documents = documents;
	}

	public IReceiveDocumentService Documents { get; }

	public async Task Invoke(EntityProtectionArgs<IReceiveDocument> args)
	{
		if (await Documents.Select(new PrimaryKeyArgs<int> { Id = args.Entity.Id }) is not IReceiveDocument document)
			return;

		throw new NotImplementedException();
	}
}
